diff -uNrd ircd-ratbox-1.5-2/modules/core/m_nick.c ircd-rb-FDF6.3a/modules/core/m_nick.c
--- ircd-ratbox-1.5-2/modules/core/m_nick.c	Thu May 20 08:06:44 2004
+++ ircd-rb-FDF6.3a/modules/core/m_nick.c	Tue Jun  1 12:28:41 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_nick.c,v 1.122.2.6 2004/05/20 12:06:44 leeh Exp $
+ *  $Id: m_nick.c,v 1.7 2004/06/01 16:28:41 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -40,6 +40,7 @@
 #include "s_serv.h"
 #include "send.h"
 #include "channel.h"
+#include "channel_mode.h"
 #include "s_log.h"
 #include "resv.h"
 #include "msg.h"
@@ -51,6 +52,7 @@
 
 static void mr_nick(struct Client *, struct Client *, int, char **);
 static void m_nick(struct Client *, struct Client *, int, char **);
+static void m_snick(struct Client *, struct Client *, int, char **);
 static void ms_nick(struct Client *, struct Client *, int, char **);
 
 static int nick_from_server(struct Client *, struct Client *, int, char **, time_t, char *);
@@ -72,20 +74,27 @@
 	{mr_nick, m_nick, ms_nick, m_ignore, m_nick}
 };
 
+struct Message snick_msgtab = {
+	"SNICK", 0, 0, 1, 0, MFLG_SLOW, 0,
+	{m_ignore, m_snick, m_snick, m_ignore}
+};
+
 #ifndef STATIC_MODULES
 void
 _modinit(void)
 {
 	mod_add_cmd(&nick_msgtab);
+	mod_add_cmd(&snick_msgtab);
 }
 
 void
 _moddeinit(void)
 {
 	mod_del_cmd(&nick_msgtab);
+	mod_del_cmd(&snick_msgtab);
 }
 
-const char *_version = "$Revision: 1.122.2.6 $";
+const char *_version = "$Revision: 1.7 $";
 #endif
 
 /*
@@ -166,6 +175,9 @@
 {
 	char nick[NICKLEN];
 	struct Client *target_p;
+	dlink_node *lp, *lp_next;
+	struct membership *mscptr;
+	struct Channel *chptr;
 
 	if(parc < 2 || BadPtr(parv[1]))
 	{
@@ -194,6 +206,18 @@
 		return;
 	}
 
+        if (MyClient(source_p)) {
+                DLINK_FOREACH_SAFE(lp, lp_next, source_p->user->channel.head) {
+                        mscptr = lp->data;
+                        chptr = mscptr->chptr;
+                        if (can_send(chptr, source_p, mscptr) == CAN_SEND_BANNED) {
+                                sendto_one(source_p, form_str(ERR_BANNICKCHANGE), me.name,
+                                           parv[0], chptr->chname);
+                                return;
+                        }
+                }
+        }
+
 	if((target_p = find_client(nick)))
 	{
 		/* If(target_p == source_p) the client is changing nicks between
@@ -205,7 +229,7 @@
 			/* check the nick isnt exactly the same */
 			if(strcmp(target_p->name, nick))
 			{
-				change_local_nick(client_p, source_p, nick);
+				change_local_nick(client_p, source_p, nick, 0);
 				return;
 			}
 			else
@@ -227,7 +251,7 @@
 			 */
 
 			exit_client(NULL, target_p, &me, "Overridden");
-			change_local_nick(client_p, source_p, nick);
+			change_local_nick(client_p, source_p, nick, 0);
 			return;
 		}
 		else
@@ -239,7 +263,7 @@
 	}
 	else
 	{
-		change_local_nick(client_p, source_p, nick);
+		change_local_nick(client_p, source_p, nick, 0);
 		return;
 	}
 }
@@ -363,6 +387,70 @@
 
 }
 
+/*
+ * m_snick()
+ *      
+ * services forced nick change
+ *    parv[0] = sender prefix
+ *    parv[1] = original nickname
+ *    parv[2] = new nickname
+ *    parv[3] = TS
+ */
+/* This function is a shameless merger between m_nick and
+   DalNet's m_svsnick().  I have tried to cover any issue
+   that could come up.  -JailBird */
+static void
+m_snick(struct Client *client_p, struct Client *source_p,
+	int parc, char *parv[])
+{
+	struct Client* target_p;
+	struct Client* old_p;
+	char nick[NICKLEN+1];
+	time_t newts = 0;
+	char *nnick = parv[2];
+	char *nts = parv[3];
+
+	if (parc < 4 || EmptyString(nnick))
+		return;
+
+	/* Check to make sure this is comming from a service */
+	if (!IsSLine(source_p))
+		return;
+
+	/* fix the length of the nick */
+	strlcpy(nick, nnick, NICKLEN+1);
+
+	/* If the nick was bad, then just ignore the SNICK */
+	if (check_clean_nick(client_p, source_p, nick, nnick,
+			     (char *)source_p->user->server))
+		return;
+
+	newts = atol(nts);   
+
+	/* Is the nickname identical to a server's name? */
+	if (find_server(nick) != NULL)
+		return;
+
+	/* Does the person even exist? */
+	if ((old_p = find_client(parv[1])) == NULL)
+		return;
+
+	/* Do we have a collision situation? */
+	if ((target_p = find_client(nick)) != NULL)
+		if (target_p->tsinfo <= newts)
+			return;
+
+	/* Nick the same */
+	if (target_p == old_p)
+		if (!strcmp(target_p->name, nick))
+			return;
+
+	if (hunt_server(client_p, source_p, ":%s SNICK %s %s :%s", 1, parc, parv)
+			!=HUNTED_ISME)
+		return;
+
+	change_local_nick(old_p, old_p, nick, newts);
+}
 
 /* 
  * check_clean_nick()
diff -uNrd ircd-ratbox-1.5-2/modules/core/m_part.c ircd-rb-FDF6.3a/modules/core/m_part.c
--- ircd-ratbox-1.5-2/modules/core/m_part.c	Thu May 20 08:06:44 2004
+++ ircd-rb-FDF6.3a/modules/core/m_part.c	Tue Jun  1 12:28:41 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_part.c,v 1.80.2.5 2004/05/20 12:06:44 leeh Exp $
+ *  $Id: m_part.c,v 1.3 2004/06/01 16:28:41 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -63,7 +63,7 @@
 {
 	mod_del_cmd(&part_msgtab);
 }
-const char *_version = "$Revision: 1.80.2.5 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 
 static void part_one_client(struct Client *client_p,
diff -uNrd ircd-ratbox-1.5-2/modules/core/m_quit.c ircd-rb-FDF6.3a/modules/core/m_quit.c
--- ircd-ratbox-1.5-2/modules/core/m_quit.c	Thu May 20 08:06:44 2004
+++ ircd-rb-FDF6.3a/modules/core/m_quit.c	Tue Jun  1 12:28:41 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_quit.c,v 1.39.2.3 2004/05/20 12:06:44 leeh Exp $
+ *  $Id: m_quit.c,v 1.3 2004/06/01 16:28:41 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -57,7 +57,7 @@
 	mod_del_cmd(&quit_msgtab);
 }
 
-const char *_version = "$Revision: 1.39.2.3 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 /*
 ** m_quit
diff -uNrd ircd-ratbox-1.5-2/modules/core/m_server.c ircd-rb-FDF6.3a/modules/core/m_server.c
--- ircd-ratbox-1.5-2/modules/core/m_server.c	Thu May 20 08:06:44 2004
+++ ircd-rb-FDF6.3a/modules/core/m_server.c	Sat Jun 19 22:46:00 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_server.c,v 1.113.2.3 2004/05/20 12:06:44 leeh Exp $
+ *  $Id: m_server.c,v 1.6 2004/06/01 16:28:41 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -68,7 +68,7 @@
 {
 	mod_del_cmd(&server_msgtab);
 }
-const char *_version = "$Revision: 1.113.2.3 $";
+const char *_version = "$Revision: 1.6 $";
 #endif
 
 int bogus_host(char *host);
@@ -419,8 +419,6 @@
 		return;
 	}
 
-
-
 	if(strlen(name) > HOSTLEN)
 	{
 		sendto_realops_flags(UMODE_ALL, L_ADMIN,
@@ -431,6 +429,18 @@
 				     client_p->name, name);
 
 		exit_client(NULL, client_p, &me, "Invalid servername introduced.");
+		return;
+	}
+
+	if (!IsCapable(client_p, CAP_FDF))
+	{
+		sendto_realops_flags(UMODE_ALL, L_ADMIN,
+				     "Link %s dropped, non-FDF server",
+				     get_client_name(client_p, HIDE_IP));
+		sendto_realops_flags(UMODE_ALL, L_OPER,
+				     "Link %s dropped, non-FDF server",
+				     get_client_name(client_p, MASK_IP));
+		exit_client(NULL, client_p, &me, "Non-FDF server");
 		return;
 	}
 
diff -uNrd ircd-ratbox-1.5-2/modules/core/m_sjoin.c ircd-rb-FDF6.3a/modules/core/m_sjoin.c
--- ircd-ratbox-1.5-2/modules/core/m_sjoin.c	Thu May 20 08:06:44 2004
+++ ircd-rb-FDF6.3a/modules/core/m_sjoin.c	Sat Jun 19 22:25:03 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_sjoin.c,v 1.175.2.8 2004/05/20 12:06:44 leeh Exp $
+ *  $Id: m_sjoin.c,v 1.9 2004/06/20 02:25:03 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -64,7 +64,7 @@
 	mod_del_cmd(&sjoin_msgtab);
 }
 
-const char *_version = "$Revision: 1.175.2.8 $";
+const char *_version = "$Revision: 1.9 $";
 #endif
 /*
  * ms_sjoin
@@ -162,6 +162,9 @@
 		case 't':
 			mode.mode |= MODE_TOPICLIMIT;
 			break;
+		case 'c':
+			mode.mode |= MODE_NOCOLOR;
+			break;
 		case 'k':
 			strlcpy(mode.key, parv[4 + args], sizeof(mode.key));
 			args++;
@@ -196,17 +199,6 @@
 
 	oldmode = &chptr->mode;
 
-#ifdef IGNORE_BOGUS_TS
-	if(newts < 800000000)
-	{
-		sendto_realops_flags(UMODE_DEBUG, L_ALL,
-				     "*** Bogus TS %lu on %s ignored from %s",
-				     (unsigned long) newts, chptr->chname, client_p->name);
-
-		newts = (oldts == 0) ? oldts : 800000000;
-	}
-#else
-
 	if(!isnew && !newts && oldts)
 	{
 		sendto_channel_local(ALL_MEMBERS, chptr,
@@ -216,7 +208,6 @@
 				     "Server %s changing TS on %s from %lu to 0",
 				     source_p->name, chptr->chname, oldts);
 	}
-#endif
 
 	if(isnew)
 		chptr->channelts = tstosend = newts;
@@ -492,6 +483,7 @@
 	{MODE_MODERATED, 'm'},
 	{MODE_INVITEONLY, 'i'},
 	{MODE_PRIVATE, 'p'},
+	{MODE_NOCOLOR, 'c'},
 	{0, 0}
 };
 
diff -uNrd ircd-ratbox-1.5-2/modules/core/m_squit.c ircd-rb-FDF6.3a/modules/core/m_squit.c
--- ircd-ratbox-1.5-2/modules/core/m_squit.c	Thu May 20 08:06:45 2004
+++ ircd-rb-FDF6.3a/modules/core/m_squit.c	Tue Jun  1 12:28:41 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_squit.c,v 1.67.2.3 2004/05/20 12:06:45 leeh Exp $
+ *  $Id: m_squit.c,v 1.3 2004/06/01 16:28:41 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -59,7 +59,7 @@
 {
 	mod_del_cmd(&squit_msgtab);
 }
-const char *_version = "$Revision: 1.67.2.3 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 struct squit_parms
 {
diff -uNrd ircd-ratbox-1.5-2/modules/descrip.mms ircd-rb-FDF6.3a/modules/descrip.mms
--- ircd-ratbox-1.5-2/modules/descrip.mms	Thu Jun 26 10:02:11 2003
+++ ircd-rb-FDF6.3a/modules/descrip.mms	Mon Jan 19 22:26:02 2004
@@ -1,6 +1,6 @@
 # MMS/MMK Makefile for OpenVMS
 # Copyright (c) 2001 Edward Brocklesby
-# $Id: descrip.mms,v 1.7.2.1 2003/06/26 14:02:11 androsyn Exp $
+# $Id: descrip.mms,v 1.1.1.1 2004/01/20 03:26:02 jailbird Exp $
 
 CC=	CC
 CFLAGS=	/INCLUDE_DIRECTORY=([-.INCLUDE],[-.ADNS])/STANDARD=ISOC94
diff -uNrd ircd-ratbox-1.5-2/modules/m_accept.c ircd-rb-FDF6.3a/modules/m_accept.c
--- ircd-ratbox-1.5-2/modules/m_accept.c	Thu May 20 08:06:35 2004
+++ ircd-rb-FDF6.3a/modules/m_accept.c	Mon May 31 00:02:21 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_accept.c,v 1.49.2.3 2004/05/20 12:06:35 leeh Exp $
+ *  $Id: m_accept.c,v 1.3 2004/05/31 04:02:21 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -62,7 +62,7 @@
 	mod_del_cmd(&accept_msgtab);
 }
 
-const char *_version = "$Revision: 1.49.2.3 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 /*
  * m_accept - ACCEPT command handler
diff -uNrd ircd-ratbox-1.5-2/modules/m_admin.c ircd-rb-FDF6.3a/modules/m_admin.c
--- ircd-ratbox-1.5-2/modules/m_admin.c	Thu May 20 08:06:35 2004
+++ ircd-rb-FDF6.3a/modules/m_admin.c	Mon May 31 00:02:21 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_admin.c,v 1.50.2.6 2004/05/20 12:06:35 leeh Exp $
+ *  $Id: m_admin.c,v 1.3 2004/05/31 04:02:21 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -58,7 +58,7 @@
 {
 	mod_del_cmd(&admin_msgtab);
 }
-const char *_version = "$Revision: 1.50.2.6 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 /*
  * mr_admin - ADMIN command handler
diff -uNrd ircd-ratbox-1.5-2/modules/m_away.c ircd-rb-FDF6.3a/modules/m_away.c
--- ircd-ratbox-1.5-2/modules/m_away.c	Thu May 20 08:06:35 2004
+++ ircd-rb-FDF6.3a/modules/m_away.c	Mon May 31 00:02:22 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_away.c,v 1.47.2.4 2004/05/20 12:06:35 leeh Exp $
+ *  $Id: m_away.c,v 1.3 2004/05/31 04:02:22 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -57,7 +57,7 @@
 {
 	mod_del_cmd(&away_msgtab);
 }
-const char *_version = "$Revision: 1.47.2.4 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 /***********************************************************************
  * m_away() - Added 14 Dec 1988 by jto. 
diff -uNrd ircd-ratbox-1.5-2/modules/m_capab.c ircd-rb-FDF6.3a/modules/m_capab.c
--- ircd-ratbox-1.5-2/modules/m_capab.c	Thu May 20 08:06:35 2004
+++ ircd-rb-FDF6.3a/modules/m_capab.c	Mon May 31 00:02:22 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_capab.c,v 1.39.2.3 2004/05/20 12:06:35 leeh Exp $
+ *  $Id: m_capab.c,v 1.3 2004/05/31 04:02:22 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -53,7 +53,7 @@
 	mod_del_cmd(&capab_msgtab);
 }
 
-const char *_version = "$Revision: 1.39.2.3 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 
 /*
diff -uNrd ircd-ratbox-1.5-2/modules/m_challenge.c ircd-rb-FDF6.3a/modules/m_challenge.c
--- ircd-ratbox-1.5-2/modules/m_challenge.c	Thu May 20 08:06:35 2004
+++ ircd-rb-FDF6.3a/modules/m_challenge.c	Mon May 31 00:02:22 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_challenge.c,v 1.56.2.3 2004/05/20 12:06:35 leeh Exp $
+ *  $Id: m_challenge.c,v 1.3 2004/05/31 04:02:22 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -57,7 +57,7 @@
 	return;
 }
 
-const char *_version = "$Revision: 1.56.2.3 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 #else
 
@@ -82,7 +82,7 @@
 	mod_del_cmd(&challenge_msgtab);
 }
 
-const char *_version = "$Revision: 1.56.2.3 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 /*
  * m_challenge - generate RSA challenge for wouldbe oper
diff -uNrd ircd-ratbox-1.5-2/modules/m_close.c ircd-rb-FDF6.3a/modules/m_close.c
--- ircd-ratbox-1.5-2/modules/m_close.c	Thu May 20 08:06:35 2004
+++ ircd-rb-FDF6.3a/modules/m_close.c	Mon May 31 00:02:22 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_close.c,v 1.36.2.3 2004/05/20 12:06:35 leeh Exp $
+ *  $Id: m_close.c,v 1.3 2004/05/31 04:02:22 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -56,7 +56,7 @@
 	mod_del_cmd(&close_msgtab);
 }
 
-const char *_version = "$Revision: 1.36.2.3 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 /*
  * mo_close - CLOSE message handler
diff -uNrd ircd-ratbox-1.5-2/modules/m_connect.c ircd-rb-FDF6.3a/modules/m_connect.c
--- ircd-ratbox-1.5-2/modules/m_connect.c	Thu May 20 08:06:35 2004
+++ ircd-rb-FDF6.3a/modules/m_connect.c	Mon May 31 00:02:22 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_connect.c,v 1.57.2.3 2004/05/20 12:06:35 leeh Exp $
+ *  $Id: m_connect.c,v 1.3 2004/05/31 04:02:22 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -63,7 +63,7 @@
 	mod_del_cmd(&connect_msgtab);
 }
 
-const char *_version = "$Revision: 1.57.2.3 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 /*
  * mo_connect - CONNECT command handler
diff -uNrd ircd-ratbox-1.5-2/modules/m_cryptlink.c ircd-rb-FDF6.3a/modules/m_cryptlink.c
--- ircd-ratbox-1.5-2/modules/m_cryptlink.c	Thu May 20 08:06:35 2004
+++ ircd-rb-FDF6.3a/modules/m_cryptlink.c	Mon May 31 00:02:22 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_cryptlink.c,v 1.56.2.4 2004/05/20 12:06:35 leeh Exp $
+ *  $Id: m_cryptlink.c,v 1.3 2004/05/31 04:02:22 jailbird Exp $
  */
 
 /*
@@ -75,7 +75,7 @@
 {
 }
 
-const char *_version = "$Revision: 1.56.2.4 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 #else
 
@@ -119,7 +119,7 @@
 	mod_del_cmd(&cryptlink_msgtab);
 }
 
-const char *_version = "$Revision: 1.56.2.4 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 
 
diff -uNrd ircd-ratbox-1.5-2/modules/m_encap.c ircd-rb-FDF6.3a/modules/m_encap.c
--- ircd-ratbox-1.5-2/modules/m_encap.c	Thu May 20 08:06:35 2004
+++ ircd-rb-FDF6.3a/modules/m_encap.c	Mon May 31 00:02:22 2004
@@ -26,7 +26,7 @@
  * IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
  * POSSIBILITY OF SUCH DAMAGE.
  *
- * $Id: m_encap.c,v 1.7.2.4 2004/05/20 12:06:35 leeh Exp $
+ * $Id: m_encap.c,v 1.3 2004/05/31 04:02:22 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -67,7 +67,7 @@
 	mod_del_cmd(&encap_msgtab);
 }
 
-const char *_version = "$Revision: 1.7.2.4 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 
 /* ms_encap()
diff -uNrd ircd-ratbox-1.5-2/modules/m_etrace.c ircd-rb-FDF6.3a/modules/m_etrace.c
--- ircd-ratbox-1.5-2/modules/m_etrace.c	Thu May 20 08:06:35 2004
+++ ircd-rb-FDF6.3a/modules/m_etrace.c	Mon May 31 00:02:22 2004
@@ -28,7 +28,7 @@
  *  IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
  *  POSSIBILITY OF SUCH DAMAGE.
  *
- *  $Id: m_etrace.c,v 1.4.2.3 2004/05/20 12:06:35 leeh Exp $
+ *  $Id: m_etrace.c,v 1.3 2004/05/31 04:02:22 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -70,7 +70,7 @@
 {
 	mod_del_cmd(&etrace_msgtab);
 }
-const char *_version = "$Revision: 1.4.2.3 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 
 
diff -uNrd ircd-ratbox-1.5-2/modules/m_gline.c ircd-rb-FDF6.3a/modules/m_gline.c
--- ircd-ratbox-1.5-2/modules/m_gline.c	Thu May 20 08:06:35 2004
+++ ircd-rb-FDF6.3a/modules/m_gline.c	Mon May 31 00:02:22 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_gline.c,v 1.119.2.9 2004/05/20 12:06:35 leeh Exp $
+ *  $Id: m_gline.c,v 1.4 2004/05/31 04:02:22 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -106,7 +106,7 @@
 	mod_del_cmd(&gline_msgtab);
 }
 
-const char *_version = "$Revision: 1.119.2.9 $";
+const char *_version = "$Revision: 1.4 $";
 #endif
 /*
  * mo_gline()
@@ -115,7 +115,7 @@
  * output       -
  * side effects -
  *
- * Place a G line if 3 opers agree on the identical user@host
+ * Place a G line if 2 opers agree on the identical user@host
  * 
  */
 /* Allow this server to pass along GLINE if received and
@@ -141,120 +141,112 @@
 		return;
 	}
 
-	if(ConfigFileEntry.glines)
+	if(!IsOperGline(source_p))
 	{
-		if(!IsOperGline(source_p))
-		{
-			sendto_one(source_p, ":%s NOTICE %s :You need gline = yes;", me.name,
-				   parv[0]);
-			return;
-		}
-
-		if((host = strchr(parv[1], '@')) || *parv[1] == '*')
-		{
-			/* Explicit user@host mask given */
-
-			if(host)	/* Found user@host */
-			{
-				user = parv[1];	/* here is user part */
-				*(host++) = '\0';	/* and now here is host */
+		sendto_one(source_p, ":%s NOTICE %s :You need gline = yes;", me.name,
+			   parv[0]);
+		return;
+	}
 
-				/* gline for "@host", use *@host */
-				if(*user == '\0')
-					user = "*";
-			}
-			else
-			{
-				user = "*";	/* no @ found, assume its *@somehost */
-				host = parv[1];
-			}
+	if((host = strchr(parv[1], '@')) || *parv[1] == '*')
+	{
+		/* Explicit user@host mask given */
 
-			if(!*host)	/* duh. no host found, assume its '*' host */
-				host = star;
+		if(host)	/* Found user@host */
+		{
+			user = parv[1];	/* here is user part */
+			*(host++) = '\0';	/* and now here is host */
 
-			strlcpy(tempuser, user, sizeof(tempuser));	/* allow for '*' */
-			strlcpy(temphost, host, sizeof(temphost));
-			user = tempuser;
-			host = temphost;
+			/* gline for "@host", use *@host */
+			if(*user == '\0')
+				user = "*";
 		}
 		else
 		{
-			sendto_one(source_p, ":%s NOTICE %s :Can't G-Line a nick use user@host",
-				   me.name, parv[0]);
-			return;
+			user = "*";	/* no @ found, assume its *@somehost */
+			host = parv[1];
 		}
 
-		if(invalid_gline(source_p, user, host, parv[2]))
-			return;
+		if(!*host)	/* duh. no host found, assume its '*' host */
+			host = star;
 
-		/* Not enough non-wild characters were found, assume they are trying to gline *@*. */
-		if(check_wild_gline(user, host))
-		{
-			if(MyClient(source_p))
-				sendto_one(source_p,
-					   ":%s NOTICE %s :Please include at least %d non-wildcard characters with the user@host",
-					   me.name, parv[0], ConfigFileEntry.min_nonwildcard);
-			return;
-		}
+		strlcpy(tempuser, user, sizeof(tempuser));	/* allow for '*' */
+		strlcpy(temphost, host, sizeof(temphost));
+		user = tempuser;
+		host = temphost;
+	}
+	else
+	{
+		sendto_one(source_p, ":%s NOTICE %s :Can't G-Line a nick use user@host",
+			   me.name, parv[0]);
+		return;
+	}
 
-		if((ptr = strchr(host, '/')) != NULL)
-		{
-			int bitlen;
-			bitlen = strtol(++ptr, NULL, 10); 
+	if(invalid_gline(source_p, user, host, parv[2]))
+		return;
 
-			if(strchr(host, ':') == NULL)
-			{
-				if(bitlen < ConfigFileEntry.gline_min_cidr)
-				{
-					sendto_one(source_p, ":%s NOTICE %s :Cannot set G-Lines with cidr length < %d", 
-						me.name, parv[0], ConfigFileEntry.gline_min_cidr);
-					return;
-				}
-			}
-			else if(bitlen < ConfigFileEntry.gline_min_cidr6)
+	/* Not enough non-wild characters were found, assume they are trying to gline *@*. */
+	if(check_wild_gline(user, host))
+	{
+		if(MyClient(source_p))
+			sendto_one(source_p,
+				   ":%s NOTICE %s :Please include at least %d non-wildcard characters with the user@host",
+				   me.name, parv[0], ConfigFileEntry.min_nonwildcard);
+		return;
+	}
+
+	if((ptr = strchr(host, '/')) != NULL)
+	{
+		int bitlen;
+		bitlen = strtol(++ptr, NULL, 10); 
+
+		if(strchr(host, ':') == NULL)
+		{
+			if(bitlen < ConfigFileEntry.gline_min_cidr)
 			{
 				sendto_one(source_p, ":%s NOTICE %s :Cannot set G-Lines with cidr length < %d", 
-					me.name, parv[0], ConfigFileEntry.gline_min_cidr6);
+					me.name, parv[0], ConfigFileEntry.gline_min_cidr);
 				return;
 			}
-				
 		}
+		else if(bitlen < ConfigFileEntry.gline_min_cidr6)
+		{
+			sendto_one(source_p, ":%s NOTICE %s :Cannot set G-Lines with cidr length < %d", 
+				me.name, parv[0], ConfigFileEntry.gline_min_cidr6);
+			return;
+		}
+			
+	}
 
+	reason = parv[2];
 
-		reason = parv[2];
-
-		/* inform users about the gline before we call check_majority_gline()
-		 * so already voted comes below gline request --fl
-		 */
-		sendto_realops_flags(UMODE_ALL, L_ALL,
-				     "%s!%s@%s on %s is requesting gline for [%s@%s] [%s]",
-				     source_p->name,
-				     source_p->username,
-				     source_p->host, me.name, user, host, reason);
-		log_gline_request(source_p->name,
-				  (const char *) source_p->username,
-				  source_p->host, me.name, user, host, reason);
+	/* inform users about the gline before we call check_majority_gline()
+	 * so already voted comes below gline request --fl
+	 */
+	sendto_realops_flags(UMODE_ALL, L_ALL,
+			     "%s!%s@%s on %s is requesting gline for [%s@%s] [%s]",
+			     source_p->name,
+			     source_p->username,
+			     source_p->host, me.name, user, host, reason);
+	log_gline_request(source_p->name,
+			  (const char *) source_p->username,
+			  source_p->host, me.name, user, host, reason);
 
-		/* If at least 3 opers agree this user should be G lined then do it */
-		check_majority_gline(source_p,
-				     source_p->name,
-				     (const char *) source_p->username,
-				     source_p->host, me.name, user, host, reason);
+	/* If at least 2 opers agree this user should be G lined then do it */
+	check_majority_gline(source_p,
+			     source_p->name,
+			     (const char *) source_p->username,
+			     source_p->host, me.name, user, host, reason);
 
-		/* 4 param version for hyb-7 servers */
-		sendto_server(NULL, NULL, CAP_GLN, NOCAPS,
-			      ":%s GLINE %s %s :%s", source_p->name, user, host, reason);
+	/* 4 param version for hyb-7 servers */
+	sendto_server(NULL, NULL, CAP_GLN, NOCAPS,
+		      ":%s GLINE %s %s :%s", source_p->name, user, host, reason);
 
-		/* 8 param for hyb-6 */
-		sendto_server(NULL, NULL, NOCAPS, CAP_GLN,
-			      ":%s GLINE %s %s %s %s %s %s :%s",
-			      me.name, source_p->name, source_p->username,
-			      source_p->host, source_p->user->server, user, host, reason);
-	}
-	else
-	{
-		sendto_one(source_p, ":%s NOTICE %s :GLINE disabled", me.name, parv[0]);
-	}
+	/* 8 param for hyb-6 */
+	sendto_server(NULL, NULL, NOCAPS, CAP_GLN,
+		      ":%s GLINE %s %s %s %s %s %s :%s",
+		      me.name, source_p->name, source_p->username,
+		      source_p->host, source_p->user->server, user, host, reason);
 }
 
 /*
@@ -264,7 +256,7 @@
  * output       -
  * side effects -
  *
- * Place a G line if 3 opers agree on the identical user@host
+ * Place a G line if 2 opers agree on the identical user@host
  * 
  */
 /* Allow this server to pass along GLINE if received and
@@ -318,39 +310,27 @@
 		      acptr->user->server, acptr->name, acptr->username,
 		      acptr->host, acptr->user->server, user, host, reason);
 
-	if(ConfigFileEntry.glines)
+	/* I dont like the idea of checking for x non-wildcard chars in a
+	 * gline.. it could lead to a desync... but we have to stop people
+	 * glining *@*..   -- fl */
+	if(check_wild_gline(user, host))
 	{
-		/* I dont like the idea of checking for x non-wildcard chars in a
-		 * gline.. it could lead to a desync... but we have to stop people
-		 * glining *@*..   -- fl */
-		if(check_wild_gline(user, host))
-		{
-			sendto_realops_flags(UMODE_ALL, L_ALL,
-					     "%s!%s@%s on %s is requesting a gline without %d non-wildcard characters for [%s@%s] [%s]",
-					     acptr->name, acptr->username,
-					     acptr->host, acptr->user->server,
-					     ConfigFileEntry.min_nonwildcard, user, host, reason);
-			return;
-		}
+		sendto_realops_flags(UMODE_ALL, L_ALL,
+				     "%s!%s@%s on %s is requesting a gline without %d non-wildcard characters for [%s@%s] [%s]",
+				     acptr->name, acptr->username,
+				     acptr->host, acptr->user->server,
+				     ConfigFileEntry.min_nonwildcard, user, host, reason);
+		return;
+	}
 
-		if((ptr = strchr(host, '/')) != NULL)
-		{
-			int bitlen;
-			bitlen = strtol(++ptr, NULL, 10);
+	if((ptr = strchr(host, '/')) != NULL)
+	{
+		int bitlen;
+		bitlen = strtol(++ptr, NULL, 10);
 
-			if(strchr(host, ':') == NULL)
-			{
-				if(bitlen < ConfigFileEntry.gline_min_cidr)
-				{
-					sendto_realops_flags(UMODE_ALL, L_ALL, "%s!%s@%s on %s is requesting "
-						"a gline with a cidr mask < %d for [%s@%s] [%s]",
-						acptr->name, acptr->username,
-						acptr->host, acptr->user->server,
-						ConfigFileEntry.gline_min_cidr, user, host, reason);
-					return;
-				}
-			}
-			else if(bitlen < ConfigFileEntry.gline_min_cidr6)
+		if(strchr(host, ':') == NULL)
+		{
+			if(bitlen < ConfigFileEntry.gline_min_cidr)
 			{
 				sendto_realops_flags(UMODE_ALL, L_ALL, "%s!%s@%s on %s is requesting "
 					"a gline with a cidr mask < %d for [%s@%s] [%s]",
@@ -360,21 +340,30 @@
 				return;
 			}
 		}
-		
-		log_gline_request(acptr->name, acptr->username, acptr->host,
-				  acptr->user->server, user, host, reason);
+		else if(bitlen < ConfigFileEntry.gline_min_cidr6)
+		{
+			sendto_realops_flags(UMODE_ALL, L_ALL, "%s!%s@%s on %s is requesting "
+				"a gline with a cidr mask < %d for [%s@%s] [%s]",
+				acptr->name, acptr->username,
+				acptr->host, acptr->user->server,
+				ConfigFileEntry.gline_min_cidr, user, host, reason);
+			return;
+		}
+	}
+	
+	log_gline_request(acptr->name, acptr->username, acptr->host,
+			  acptr->user->server, user, host, reason);
 
-		sendto_realops_flags(UMODE_ALL, L_ALL,
-				     "%s!%s@%s on %s is requesting gline for [%s@%s] [%s]",
-				     acptr->name, acptr->username,
-				     acptr->host, acptr->user->server,
-				     user, host, reason);
+	sendto_realops_flags(UMODE_ALL, L_ALL,
+			     "%s!%s@%s on %s is requesting gline for [%s@%s] [%s]",
+			     acptr->name, acptr->username,
+			     acptr->host, acptr->user->server,
+			     user, host, reason);
 
-		/* If at least 3 opers agree this user should be G lined then do it */
-		check_majority_gline(source_p, acptr->name, acptr->username,
-				     acptr->host, acptr->user->server,
-				     user, host, reason);
-	}
+	/* If at least 2 opers agree this user should be G lined then do it */
+	check_majority_gline(source_p, acptr->name, acptr->username,
+			     acptr->host, acptr->user->server,
+			     user, host, reason);
 }
 
 /*
@@ -645,20 +634,6 @@
 	}
 
 	snprintf(buffer, sizeof(buffer), "#%s!%s@%s on %s [%s]\n",
-		   gline_pending_ptr->oper_nick2,
-		   gline_pending_ptr->oper_user2,
-		   gline_pending_ptr->oper_host2,
-		   gline_pending_ptr->oper_server2,
-		   (gline_pending_ptr->reason2) ? (gline_pending_ptr->reason2) : "No reason");
-
-	if(fbputs(buffer, out) == -1)
-	{
-		sendto_realops_flags(UMODE_ALL, L_ALL, "*** Problem writing to %s", filenamebuf);
-		fbclose(out);
-		return;
-	}
-
-	snprintf(buffer, sizeof(buffer), "#%s!%s@%s on %s [%s]\n",
 		   oper_nick, oper_user, oper_host, oper_server, (reason) ? reason : "No reason");
 
 	if(fbputs(buffer, out) == -1)
@@ -720,7 +695,6 @@
 	strlcpy(pending->user, user, sizeof(pending->user));
 	strlcpy(pending->host, host, sizeof(pending->host));
 	DupString(pending->reason1, reason);
-	pending->reason2 = NULL;
 
 	pending->last_gline_time = CurrentTime;
 	pending->time_request1 = CurrentTime;
@@ -734,11 +708,11 @@
  * inputs       - oper_nick, oper_user, oper_host, oper_server
  *                user,host reason
  *
- * output       - YES if there are 3 different opers on 3 different servers
+ * output       - YES if there are 2 different opers on 2 different servers
  *                agreeing to this gline, NO if there are not.
  * Side effects -
  *      See if there is a majority agreement on a GLINE on the given user
- *      There must be at least 3 different opers agreeing on this GLINE
+ *      There must be at least 2 different opers agreeing on this GLINE
  *
  */
 static int
@@ -757,6 +731,12 @@
 
 	/* special case condition where there are no pending glines */
 
+	if (IsSLine(source_p)) {
+		set_local_gline(oper_nick, oper_user, oper_host, oper_server,
+				user, host, reason);
+		return YES;
+	}
+
 	if(dlink_list_length(&pending_glines) == 0)	/* first gline request placed */
 	{
 		add_new_majority_gline(oper_nick, oper_user, oper_host, oper_server,
@@ -784,46 +764,14 @@
 				return NO;
 			}
 
-			if(gline_pending_ptr->oper_user2[0] != '\0')
-			{
-				/* if two other opers on two different servers have voted yes */
-				if(((irccmp(gline_pending_ptr->oper_user2, oper_user) == 0) ||
-				    (irccmp(gline_pending_ptr->oper_host2, oper_host) == 0)))
-				{
-					sendto_realops_flags(UMODE_ALL, L_ALL,
-							     "oper has already voted");
-					return NO;
-				}
-				else if(irccmp(gline_pending_ptr->oper_server2, oper_server) == 0)
-				{
-					sendto_realops_flags(UMODE_ALL, L_ALL,
-							     "server has already voted");
-					return NO;
-				}
-
-				log_gline(source_p, gline_pending_ptr,
-					  oper_nick, oper_user, oper_host, oper_server,
-					  user, host, reason);
+			log_gline(source_p, gline_pending_ptr,
+				  oper_nick, oper_user, oper_host, oper_server,
+				  user, host, reason);
 
-				/* trigger the gline using the original reason --fl */
-				set_local_gline(oper_nick, oper_user, oper_host, oper_server,
-						user, host, gline_pending_ptr->reason1);
-				return YES;
-			}
-			else
-			{
-				strlcpy(gline_pending_ptr->oper_nick2, oper_nick,
-					sizeof(gline_pending_ptr->oper_nick2));
-				strlcpy(gline_pending_ptr->oper_user2, oper_user,
-					sizeof(gline_pending_ptr->oper_user2));
-				strlcpy(gline_pending_ptr->oper_host2, oper_host,
-					sizeof(gline_pending_ptr->oper_host2));
-				DupString(gline_pending_ptr->reason2, reason);
-				gline_pending_ptr->oper_server2 = find_or_add(oper_server);
-				gline_pending_ptr->last_gline_time = CurrentTime;
-				gline_pending_ptr->time_request2 = CurrentTime;
-				return NO;
-			}
+			/* trigger the gline using the original reason --fl */
+			set_local_gline(oper_nick, oper_user, oper_host, oper_server,
+					user, host, gline_pending_ptr->reason1);
+			return YES;
 		}
 	}
 	/* Didn't find this user@host gline in pending gline list
